# Hippy Contributing Guide

Hi! I'm really excited that you are interested in contributing to Hippy. Before submitting your contribution, please make sure to take a moment and read through the following guidelines:

- [Code of Conduct](https://github.com/Tencent/Hippy/blob/master/.github/CODE_OF_CONDUCT.md)
- [Issue Reporting Guidelines](#issue-reporting-guidelines)
- [Pull Request Guidelines](#pull-request-guidelines)
- [Development Setup](https://github.com/Tencent/Hippy#-getting-started)
- [Project Structure](https://github.com/Tencent/Hippy#-project-structure)

## Issue Reporting Guidelines

- Always use [Bug Report](https://github.com/Tencent/Hippy/blob/master/.github/ISSUE_TEMPLATE/bug_report.md) or [Feature Request](https://github.com/Tencent/Hippy/blob/master/.github/ISSUE_TEMPLATE/feature_request.md) to create new issues.

## Pull Request Guidelines

- Setting up your local environment to get started. You will need have [git](https://git-scm.com/) and [npm](https://docs.npmjs.com/downloading-and-installing-node-js-and-npm) installed locally, then run `npm install` to download all needed dependencies. These are detailed in the [Development Setup guide](https://github.com/Tencent/Hippy#-getting-started). 

- Checkout a topic branch from the relevant branch, e.g. `master`, and merge back against that branch.

- Test cases have been added/updated/passed for the code you will submit.

- Documentation has added or updated.

- Commit message is following the [Convention Commit](https://conventionalcommits.org/) guideline with maximum 72 characters.

- Squash the repeat code commits, short patches are welcome.
